=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2007-01-30 10:51:38 +0000
+++ bzrlib/trace.py	2007-03-27 04:57:59 +0000
@@ -181,6 +181,8 @@
 
     The exception string representation is used as the error
     summary, unless msg is given.
+
+    Please see log_exception_quietly() for the replacement API.
     """
     if msg:
         error(msg)

=== modified file 'bzrlib/transport/smart.py'
--- bzrlib/transport/smart.py	2007-03-27 04:21:26 +0000
+++ bzrlib/transport/smart.py	2007-03-27 04:57:59 +0000
@@ -853,15 +853,20 @@
         for hook in SmartTCPServer.hooks['server_started']:
             hook(self.backing_transport.base, self.get_url())
         try:
-            while not self._should_terminate:
-                try:
-                    self.accept_and_serve()
-                except socket_timeout:
-                    # just check if we're asked to stop
-                    pass
-                except socket_error, e:
-                    trace.warning("client disconnected: %s", e)
-                    pass
+            try:
+                while not self._should_terminate:
+                    try:
+                        self.accept_and_serve()
+                    except socket_timeout:
+                        # just check if we're asked to stop
+                        pass
+                    except socket_error, e:
+                        trace.warning("client disconnected: %s", e)
+                        pass
+            except Exception, e:
+                trace.error("Unhandled smart server error.")
+                trace.log_exception_quietly()
+                raise
         finally:
             try:
                 self._server_socket.close()

